      subroutine GAUSSN2(g,gnoise,s,sizg,factor)

C=======================================================================
C
c      parameter (maxsiz=1050)
      IMPLICIT NONE
	INTEGER maxsiz
	parameter (maxsiz=1050)

      INTEGER I,N,IDUM,NOVER,sizg
      
 4    real g(maxsiz),s(maxsiz),gnoise(maxsiz),factor
      REAL SIGMA,Q,X(99999),GASDEV,MEAN,SDEV,SDEV1,QQ
C
      WRITE(6,*) '=== Enter :                          ==='
      WRITE(6,*) '=== number of random numbers to skip ==='
ccccc WRITE(6,*) '=== number of random numbers to use  ==='
      WRITE(6,*) '=== (maximum: 99999)                 ==='
	READ(5,*) NOVER
      WRITE(6,*) '=== sigma                            ==='
      READ(5,*) SIGMA
ccccccccccccc
      N=sizg
Ccccccccccccc
      IDUM = 0
      DO I=1,NOVER,1
         Q = GASDEV(IDUM)
      ENDDO
      DO I=1,N,1
         Q = GASDEV(IDUM)
         X(I) = Q*SIGMA
      ENDDO
C
      MEAN = 0.0
      DO I=1,N,1
         MEAN = MEAN+X(I)
      ENDDO
      MEAN = MEAN/FLOAT(N)
C
      SDEV = 0.0
      DO I=1,N,1
      SDEV = SDEV+(X(I)-MEAN)**2
      ENDDO
      QQ = SDEV
      SDEV = SQRT(QQ/FLOAT(N))
      SDEV1 = SQRT(QQ/FLOAT(N-1))
C

c	open(200,file='../data/g&gauss.asc')
c	open(300,file='../data/s.asc')

c	write(200,*) sizg,'  0'
c	write(300,*) sizg,'  0'
c-------------------------------------------------------
      DO I=1,N,1

c====	scaling to flux like this:?
	x(i)=x(i)*g(i)	
c====
      	gnoise(i)=g(i)+x(i)

c
c       s(i)=sdev*factor
c====   scaling to flux like this:?
	s(i)=sdev*g(i)
c====
		
c          s(i)=sigma
c         WRITE(6,*) X(I)
c         write(200,*) gnoise(i) 
c        write(300,*) s(i)

      ENDDO
c-------------------------------------------------------

c      close(200)
c      close(300)
      
      WRITE(6,*) '-----------------------------------------------------'
      WRITE(6,*) 'MEAN      = ',MEAN
      WRITE(6,*) 'SEDV(N)   = ',SDEV
      WRITE(6,*) 'SEDV(N-1) = ',SDEV1
      WRITE(6,*) 'Sigma used in vector S =',sdev*factor
C
      return

      END
C
C-----------------------------------------------------------------------
C  FUNCTION:  GASDEV
C  SOURCE:    PRESS et al. Numerical Recipes
C-----------------------------------------------------------------------
C
      FUNCTION GASDEV(IDUM)
      DATA ISET/0/
      IF (ISET.EQ.0) THEN
 1        V1=2.*RAN1(IDUM)-1.
          V2=2.*RAN1(IDUM)-1.
          R=V1**2+V2**2
          IF(R.GT.1.)GO TO 1
          FAC=SQRT(-2.*LOG(R)/R)
          GSET=V1*FAC
          GASDEV=V2*FAC
          ISET=1
      ELSE
          GASDEV=GSET
          ISET=0
      ENDIF
      RETURN
      END
C
C-----------------------------------------------------------------------
C  FUNCTION:  RAN1
C  SOURCE:    PRESS et al. Numerical Recipes
C-----------------------------------------------------------------------
C
      FUNCTION RAN1(IDUM)
      DIMENSION R(97)
      PARAMETER (M1=259200,IA1=7141,IC1=54773,RM1=3.8580247E-6)
      PARAMETER (M2=134456,IA2=8121,IC2=28411,RM2=7.4373773E-6)
      PARAMETER (M3=243000,IA3=4561,IC3=51349)
      DATA IFF /0/
      IF (IDUM.LT.0.OR.IFF.EQ.0) THEN
        IFF=1
        IX1=MOD(IC1-IDUM,M1)
        IX1=MOD(IA1*IX1+IC1,M1)
        IX2=MOD(IX1,M2)
        IX1=MOD(IA1*IX1+IC1,M1)
        IX3=MOD(IX1,M3)
        DO 11 J=1,97
          IX1=MOD(IA1*IX1+IC1,M1)
          IX2=MOD(IA2*IX2+IC2,M2)
          R(J)=(FLOAT(IX1)+FLOAT(IX2)*RM2)*RM1
11      CONTINUE
        IDUM=1
      ENDIF
      IX1=MOD(IA1*IX1+IC1,M1)
      IX2=MOD(IA2*IX2+IC2,M2)
      IX3=MOD(IA3*IX3+IC3,M3)
      J=1+(97*IX3)/M3
      IF(J.GT.97.OR.J.LT.1)PAUSE
      RAN1=R(J)
      R(J)=(FLOAT(IX1)+FLOAT(IX2)*RM2)*RM1
      RETURN
      END
C
C-----------------------------------------------------------------------
C  FUNCTION:  RAN2
C  SOURCE:    PRESS et al. Numerical Recipes
C-----------------------------------------------------------------------
C
      FUNCTION RAN2(IDUM)
      PARAMETER (M=714025,IA=1366,IC=150889,RM=1.4005112E-6)
      DIMENSION IR(97)
      DATA IFF /0/
      IF(IDUM.LT.0.OR.IFF.EQ.0)THEN
        IFF=1
        IDUM=MOD(IC-IDUM,M)
        DO 11 J=1,97
          IDUM=MOD(IA*IDUM+IC,M)
          IR(J)=IDUM
11      CONTINUE
        IDUM=MOD(IA*IDUM+IC,M)
        IY=IDUM
      ENDIF
      J=1+(97*IY)/M
      IF(J.GT.97.OR.J.LT.1)PAUSE
      IY=IR(J)
      RAN2=IY*RM
      IDUM=MOD(IA*IDUM+IC,M)
      IR(J)=IDUM
      RETURN
      END
